View Issue Details

IDCategoryLast Update
0006768features2016-11-14 03:32
ReportertimbyrAssigned Totimbyr 
ReproducibilityN/A 
Status assignedResolutionopen 
Product Version 
Fixed in Version 
Summary0006768: Zoom Editor track area/canvas by clicking and dragging in the ruler
DescriptionSome other DAW's have the ability to zoom by clicking and dragging in a certain area of the canvas. In Ableton and Cubase this is in the ruler area.

I'm reporting this issue to see if there is any interest in having similar functionality in Ardour.

I prefer to use this functionality to zoom in those applications as it allows me to use the "nipple" on my laptop to zoom without moving my hands out of position.
TagsNo tags attached.

Relationships

related to 0007089 new The proposal to make the mouse zoom steps smaller 

Activities

timbyr

2016-02-11 00:40

developer  

ruler-drag-zoom.webm (3,679,162 bytes)

timbyr

2016-02-11 00:41

developer   ~0017902

I uploaded a short video to demonstrate what I mean.

timbyr

2016-02-11 01:00

developer   ~0017904

Last edited: 2016-02-11 01:01

View 2 revisions

One concern with this sort of functionality is that the performance of the canvas, as with a lot of items it can really slow the zooming operation down to the point of being almost useless.

timbyr

2016-09-09 12:03

developer   ~0018581

I have a small series of changes that implements this functionality as an option that is off by default.

If there is no negative feedback I will commit the changes so that the functionality can at least be tested.

cooltehno_bugs

2016-10-31 15:08

reporter   ~0018893

Great feature! How it would be nice to see it committed)

timbyr

2016-11-11 04:23

developer   ~0018936

This feature has been committed to master branch as of revision 5.4-317-gdac2d41 and so can be tested in a nightly >= 5.4.317

It is enabled via Preferences -> Editor -> Use time rulers area to zoom when clicking and dragging vertically

Feedback welcome.

rutsch

2016-11-12 09:16

reporter   ~0018941

Last edited: 2016-11-12 09:19

View 3 revisions

Excellent! Works great for me. Now add scrolling instead moving the playhead when moving left or right and this is perfect.

Edit: I see, it's scrolling when going to the left and right border.

timbyr

2016-11-12 11:07

developer   ~0018942

Yes, it should scroll when moving the mouse to the edge of the track canvas area.

I think there might be a few tweaks to improve it.

One would be if there was a vertical drag threshold that had to be passed in order for zooming to start so that if you just click up in the ruler it doesn't zoom unless you drag the mouse a few pixels.

The other would be to see if only zooming when the mouse moves vertically every two or three pixels instead of every pixel would improve the issue with the delay in redrawing the waveforms.

I'll try to play around with these ideas when I get time. Let me know if you can think of anything else.

rutsch

2016-11-12 15:15

reporter   ~0018943

Sounds good, nothing to add from me at this time.

cooltehno_bugs

2016-11-13 21:46

reporter   ~0018954

Thanks for contribution!
After night-build testing I've got two Ideas:

1) It could be very comfortable (from Bitwig using):
- Click+drag vertically - zooms in/out;
- Click+drag horizontally - shifts right/left.

The horizontal shifting by clicking&dragging - could be nice for your Ardour's feature!

2) The playhead goes with clicking in the area of the canvas - it's not comfortable. It would be nice to zoom and shift no effecting the playhead position. Or may be for zooming/shifting - to use a middle mouse button (left m.button - to leave for playhead positioning).

timbyr

2016-11-14 03:31

developer   ~0018960

I don't have access to Bitwig but I'm assuming this zoom/scroll operation you are describing has the same behaviour as in Ableton Live.

The way it is implemented currently was based on the behaviour in Cubase.

After using Ableton Live lite for a bit to test, I think I prefer its behaviour (and your suggestion) that it also scroll and that it not manipulate the playhead position. It seems to make navigation much easier and predictable when scrolling than trying to move the cursor to the side of the canvas to scroll.

It will probably be a bit more complicated to implement and I'll wait for some more feedback on the current behaviour before investing any time in changing it.

Issue History

Date Modified Username Field Change
2016-02-11 00:37 timbyr New Issue
2016-02-11 00:40 timbyr File Added: ruler-drag-zoom.webm
2016-02-11 00:41 timbyr Note Added: 0017902
2016-02-11 01:00 timbyr Note Added: 0017904
2016-02-11 01:01 timbyr Note Edited: 0017904 View Revisions
2016-09-09 12:03 timbyr Note Added: 0018581
2016-10-31 15:08 cooltehno_bugs Note Added: 0018893
2016-11-11 04:23 timbyr Note Added: 0018936
2016-11-11 04:24 timbyr Assigned To => timbyr
2016-11-11 04:24 timbyr Status new => feedback
2016-11-12 09:16 rutsch Note Added: 0018941
2016-11-12 09:18 rutsch Note Edited: 0018941 View Revisions
2016-11-12 09:19 rutsch Note Edited: 0018941 View Revisions
2016-11-12 11:07 timbyr Note Added: 0018942
2016-11-12 11:07 timbyr Status feedback => assigned
2016-11-12 15:15 rutsch Note Added: 0018943
2016-11-13 12:03 timbyr Relationship added related to 0007089
2016-11-13 21:46 cooltehno_bugs Note Added: 0018954
2016-11-14 03:31 timbyr Note Added: 0018960
2016-11-14 03:32 timbyr File Added: 5.4-crash-with-selected-midi-notes.bt.txt
2016-11-14 03:33 timbyr File Deleted: 5.4-crash-with-selected-midi-notes.bt.txt